## opensurgsim 0.7.0

=== CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2016, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


cmake_minimum_required(VERSION 2.8.11)
project(OpenSurgSim)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(OPENSURGSIM_MAJOR_VERSION 0)
set(OPENSURGSIM_MINOR_VERSION 7)
set(OPENSURGSIM_PATCH_VERSION 0)
set(OPENSURGSIM_VERSION
	${OPENSURGSIM_MAJOR_VERSION}.${OPENSURGSIM_MINOR_VERSION}.${OPENSURGSIM_PATCH_VERSION})

# Install Directories
set(INSTALL_LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib)
set(INSTALL_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
set(INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include)
if(WIN32 AND NOT CYGWIN)
	set(INSTALL_CMAKE_DIR ${CMAKE_INSTALL_PREFIX}/CMake)
else()
	set(INSTALL_CMAKE_DIR ${CMAKE_INSTALL_PREFIX}/lib/cmake/${PROJECT_NAME})
endif()

# Use SURGSIM_SOURCE_DIR SURGSIM_SOURCE_DIR will always point to the top of the OSS Tree
set(SURGSIM_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
set(SURGSIM_TOOLS_DIR "${SURGSIM_SOURCE_DIR}/Tools")
set(SURGSIM_THIRD_PARTY_DIR "${SURGSIM_SOURCE_DIR}/ThirdParty")
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${SURGSIM_THIRD_PARTY_DIR})

include(ExternalProject)
include(SurgSimBuildFlags)
include(SurgSimUtilities)


### Find required libraries

find_package(OpenSceneGraph 3.2 COMPONENTS osg osgViewer osgText osgUtil osgDB osgGA osgAnimation REQUIRED)
find_package(OpenThreads)
find_package(OpenGL)
if(WIN32)
	find_package(Eigen3 3.2.3 REQUIRED)
else(WIN32)
	find_package(Eigen3 3.2.1 REQUIRED)
endif(WIN32)

if(WIN32)
	set(GLUT_ROOT_PATH "$ENV{GLUT_ROOT_PATH}")
endif(WIN32)
find_package(GLUT)  # only needed for visual device tests
find_package(GlutFromOsg)  # look for GLUT in the OSG tree if not found above
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	# The standard FindGLUT code in CMake 2.8 includes some annoying old
	# junk (-lXmu -lXi) in GLUT_LIBRARIES for Unix/Linux, which is
	# neither needed nor usually available.  We only need GLUT itself.
	set(GLUT_LIBRARIES ${GLUT_glut_LIBRARY})
endif(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

if(${BUILD_SHARED_LIBS})
	set(Boost_USE_STATIC_LIBS OFF)
	add_definitions("-DBOOST_ALL_DYN_LINK")
else()
	set(Boost_USE_STATIC_LIBS ON)
endif()
set(Boost_USE_MULTITHREADED ON)
set(Boost_USE_STATIC_RUNTIME OFF)
find_package(Boost 1.54 COMPONENTS chrono date_time filesystem system thread REQUIRED)
mark_as_advanced(Boost_DIR)

# Look for platform specific pthread.
find_package(Threads REQUIRED)
# Append pthread and rt to Boost_LIBRARIES since they are boost dependancies
list(APPEND Boost_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	list(APPEND Boost_LIBRARIES rt)
endif()

find_package(yaml-cpp 0.5.2 QUIET)
if(yaml-cpp_FOUND)
	message(STATUS "Found yaml-cpp")
else()
	message(STATUS "Yaml-cpp was not found. It will be downloaded and built during the build.")
	include(External_yamlcpp)
endif()

include_directories(${SURGSIM_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(
	${Boost_INCLUDE_DIR}
	${EIGEN3_INCLUDE_DIR}
	${OSG_INCLUDE_DIR}
	${YAML_CPP_INCLUDE_DIR}
)

include(CTest)
configure_file(CTestCustom.cmake.in CTestCustom.cmake)

option(BUILD_RENDER_TESTING "Build the render testing tree." OFF)
option(BUILD_PERFORMANCE_TESTING "Build the performance testing tree." OFF)

if(BUILD_TESTING)
	set(gtest_force_shared_crt ON CACHE BOOL "Use shared CRT for Google Test [OpenSurgSim forces this to true!]" FORCE)
	find_package(GoogleMock)
	add_subdirectory(${GOOGLEMOCK_DIR} GoogleMock)
endif()

add_subdirectory(SurgSim)

option(BUILD_EXAMPLES "Build the examples." ON)

if(BUILD_EXAMPLES)
	add_subdirectory(Examples)
endif()

add_subdirectory(Modules)

option(BUILD_DOCUMENTATION "Build the documentation using Doxygen." OFF)

if(BUILD_DOCUMENTATION)
  add_subdirectory(Documentation)
endif()

#OpenSurgSimConfig For the Build Tree
set(CONFIG_INCLUDE_DIRS "${SURGSIM_SOURCE_DIR}")
set(CONFIG_DATA_DIR "${SURGSIM_SOURCE_DIR}/Data")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CMake/OpenSurgSimConfig.cmake.in
	"${PROJECT_BINARY_DIR}/OpenSurgSimConfig.cmake" @ONLY)

#OpenSurgSimConfig For the Install Tree
file(RELATIVE_PATH REL_INCLUDE_DIR "${INSTALL_CMAKE_DIR}" "${CMAKE_INSTALL_PREFIX}/include")
set(CONFIG_INCLUDE_DIRS "\${OPENSURGSIM_CMAKE_DIR}/${REL_INCLUDE_DIR}")

if (WIN32)
	file(RELATIVE_PATH REL_DATA_DIR "${INSTALL_CMAKE_DIR}" "${CMAKE_INSTALL_PREFIX}/Data")
	install(DIRECTORY Data/ DESTINATION ${CMAKE_INSTALL_PREFIX}/Data)
else (WIN32)
	file(RELATIVE_PATH REL_DATA_DIR "${INSTALL_CMAKE_DIR}" "${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}")
	install(DIRECTORY Data/ DESTINATION ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME})
endif (WIN32)
set(CONFIG_DATA_DIR "\${OPENSURGSIM_CMAKE_DIR}/${REL_DATA_DIR}")


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CMake/OpenSurgSimConfig.cmake.in
	"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/OpenSurgSimConfig.cmake" @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CMake/OpenSurgSimConfigVersion.cmake.in
	"${PROJECT_BINARY_DIR}/OpenSurgSimConfigVersion.cmake" @ONLY)


install(FILES
	"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/OpenSurgSimConfig.cmake"
	"${PROJECT_BINARY_DIR}/OpenSurgSimConfigVersion.cmake"
	DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)
install(EXPORT ${PROJECT_NAME}Targets DESTINATION ${INSTALL_CMAKE_DIR} COMPONENT dev)

surgsim_cpplint_this_tree(cpplint)

# Set these variables for Projects using Oss inside their Project structure rather than
# Through the installed version
set(OPENSURGSIM_INCLUDE_DIRS ${SURGSIM_SOURCE_DIR} CACHE INTERNAL "OSS Include Directories")
set(OPENSURGSIM_DATA_DIR ${SURGSIM_SOURCE_DIR}/Data CACHE INTERNAL "OSS Data Directory")
set(OPENSURGSIM_LIBRARIES ${SURGSIM_EXPORT_TARGETS} CACHE INTERNAL "OSS Exported Libraries")

# Copy OpenSurgSim Data folder containing common shaders and fonts to the Build folder
file(COPY Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

option(BUILD_TOOLS "Build Tool Utilities" OFF)

if(BUILD_TOOLS)
  add_subdirectory(Tools)
endif(BUILD_TOOLS)

=== Documentation/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


# Make it easier to tell CMake where to find dot for doxygen.  You can
# set the environment variable DOXYGEN_DOT_PATH to a directory path to
# where the dot binary lives.  (You don't need this on Linux if you
# install Graphviz in a standard location.)
#
# Note that the Windows installer for Graphviz 2.30 doesn't seem to
# write the install directory into the registry.
find_program(DOXYGEN_DOT_EXECUTABLE
	NAMES dot
	PATHS "$ENV{DOXYGEN_DOT_PATH}" "${DOXYGEN_DOT_PATH}"
	DOC "Graphviz Dot tool for using Doxygen")

find_package(Doxygen REQUIRED)

set(SURGSIM_DOCUMENTATION_EXCLUDE_LIST "*/UnitTests/* */RenderTests/* */PerformanceTests/*"
	CACHE STRING "Directories and files to ignore when generating documentation")
mark_as_advanced(SURGSIM_DOCUMENTATION_EXCLUDE_LIST)

set(PROJECT_LOGO "${CMAKE_CURRENT_SOURCE_DIR}/OpenSurgSim-dox.png")
set(HTML_HEADER "${CMAKE_CURRENT_SOURCE_DIR}/header.html")
set(HTML_FOOTER "${CMAKE_CURRENT_SOURCE_DIR}/footer.html")

# Set DOT_PATH to DOXYGEN_DOT_EXECUTABLE, or empty if not found.
# Eliminates whining from Doxygen.
if(DOXYGEN_DOT_FOUND)
	set(DOT_PATH "${DOXYGEN_DOT_EXECUTABLE}")
else(DOXYGEN_DOT_FOUND)
	set(DOT_PATH "")
endif(DOXYGEN_DOT_FOUND)

# Tie the documentation build to the project build.
set(DOCUMENTATION_TARGET_FLAGS ALL)

# Control the output format so warnings pop up in the Visual Studio list
if(MSVC)
	set(WARN_FORMAT "\"$file($line): warning DOC1: $text\"")
else(MSVC)
	set(WARN_FORMAT "\"$file:$line: $text\"")
endif(MSVC)

find_package(MathJax)
if(MATHJAX_FOUND)
	set(MATHJAX_RELPATH_CONFIG "MATHJAX_RELPATH = file://${MATHJAX_DIR}")
	message(STATUS "Using local MathJax: " ${MATHJAX_DIR})
else()
	set(MATHJAX_RELPATH_CONFIG "")
	message(STATUS "Using default web-based MathJax")
endif()

# Generate Doxyfile from Doxyfile.in, with @VARIABLE@ substitution.
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
	${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)

add_custom_target(documentation ${DOCUMENTATION_TARGET_FLAGS}
	${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating HTML documentation" VERBATIM)
# Put the Doxyfile.in at the top of the VS project, not "Header Files":
source_group("" FILES "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in")

if(UNIX)
	install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ 
		DESTINATION share/doc/${CMAKE_PROJECT_NAME}) 
else(UNIX)
	install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ 
		DESTINATION documentation) 
endif(UNIX)

=== Examples/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(BUILD_DEVICE_MULTIAXIS)
	add_subdirectory(AddSphereFromInput)
	add_subdirectory(Stapling)
endif(BUILD_DEVICE_MULTIAXIS)

add_subdirectory(InputVtc)

add_subdirectory(DroppingBalls)


# Not Required components
find_package(Boost 1.54 COMPONENTS program_options)

if(Boost_PROGRAM_OPTIONS_FOUND)
add_subdirectory(ShowScenery)
add_subdirectory(GraphicsScene)
else()
message("Can't build example ShowScenery, missing library boost_program_options.")
endif()

=== Modules/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB MODULES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*)
foreach(MODULE ${MODULES})
	if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}/CMakeLists.txt)
		string(TOUPPER ${MODULE} MODULE_UPPER_CASE)
		option(BUILD_MODULE_${MODULE_UPPER_CASE} "Build ${MODULE} module." OFF)
		if(BUILD_MODULE_${MODULE_UPPER_CASE})
			add_subdirectory(${MODULE})
		endif(BUILD_MODULE_${MODULE_UPPER_CASE})
	endif()
endforeach()

=== SurgSim/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2012-2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


link_directories(${Boost_LIBRARY_DIRS})

add_subdirectory(Blocks)
add_subdirectory(Collision)
add_subdirectory(DataStructures)
add_subdirectory(Devices)
add_subdirectory(Framework)
add_subdirectory(Graphics)
add_subdirectory(Input)
add_subdirectory(Math)
add_subdirectory(Particles)
add_subdirectory(Physics)
add_subdirectory(Testing)

set(SURGSIM_DEVICES_LIBRARIES ${SURGSIM_DEVICES_LIBRARIES} PARENT_SCOPE)

=== Tools/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

find_package(Boost 1.54 COMPONENTS program_options)

if(BUILD_TOOLS AND Boost_PROGRAM_OPTIONS_FOUND)
	add_subdirectory(NeedleSutureGeneration)
else()
	message("Can't build example NeedleSutureGeneration, missing library boost_program_options.")
endif(BUILD_TOOLS AND Boost_PROGRAM_OPTIONS_FOUND)

=== Examples/AddSphereFromInput/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

find_package(OpenSceneGraph COMPONENTS osg osgViewer osgText osgUtil osgDB osgGA osgAnimation REQUIRED)
find_package(OpenThreads)

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${OPENTHREADS_INCLUDE_DIR}
)

set(SOURCES
	AddSphereBehavior.cpp
	AddSphereFromInput.cpp
)

set(HEADERS
	AddSphereBehavior.h
)

surgsim_add_executable(AddSphereFromInput "${SOURCES}" "${HEADERS}")

set(LIBS 
	MultiAxisDevice
	SurgSimBlocks
	SurgSimGraphics
	SurgSimMath
	${YAML_CPP_LIBRARIES}
)

target_link_libraries(AddSphereFromInput ${LIBS})

# Put AddSphereFromInput into folder "Examples"
set_target_properties(AddSphereFromInput PROPERTIES FOLDER "Examples")

=== Examples/DroppingBalls/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${OPENTHREADS_INCLUDE_DIR}
)

set(SOURCES
	AddRandomSphereBehavior.cpp
	DroppingBalls.cpp
)

set(HEADERS
	AddRandomSphereBehavior.h
)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

surgsim_add_executable(DroppingBalls "${SOURCES}" "${HEADERS}")

SET(LIBS
	SurgSimBlocks
	SurgSimPhysics
	SurgSimGraphics
	SurgSimMath
	${YAML_CPP_LIBRARIES}
)

target_link_libraries(DroppingBalls ${LIBS})

# Put DroppingBalls into folder "Examples"
set_target_properties(DroppingBalls PROPERTIES FOLDER "Examples")

=== Examples/GraphicsScene/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

find_package(OpenSceneGraph COMPONENTS osg osgViewer osgText osgUtil osgDB osgGA osgAnimation REQUIRED)
find_package(OpenThreads)

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	"${CMAKE_CURRENT_SOURCE_DIR}"
	"${OPENTHREADS_INCLUDE_DIR}"
)

set(SOURCES
	GraphicsScene.cpp
)

set(HEADERS
)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

surgsim_add_executable(GraphicsScene "${SOURCES}" "${HEADERS}")

SET(LIBS
	SurgSimBlocks
	SurgSimGraphics
	SurgSimDevices
	${Boost_LIBRARIES}
	${YAML_CPP_LIBRARIES}
)

target_link_libraries(GraphicsScene ${LIBS})

# Put GraphicsScene into folder "Examples"
set_target_properties(GraphicsScene PROPERTIES FOLDER "Examples")

=== Examples/InputVtc/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${OPENTHREADS_INCLUDE_DIR}
)

set(SOURCES
	InputVtc.cpp
)

set(HEADERS
)

surgsim_add_executable(InputVtc "${SOURCES}" "${HEADERS}")

set(LIBS 
	SurgSimBlocks
	SurgSimDevices
	SurgSimGraphics
	SurgSimMath
	${YAML_CPP_LIBRARIES}
)


target_link_libraries(InputVtc ${LIBS})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

# Put InputVtc into folder "Examples"
set_target_properties(InputVtc PROPERTIES FOLDER "Examples")

=== Examples/ShowScenery/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

link_directories(
	${Boost_LIBRARY_DIRS}
)

include_directories(
	"${CMAKE_CURRENT_SOURCE_DIR}"
	"${OPENTHREADS_INCLUDE_DIR}"
)

set(SOURCES
	ShowScenery.cpp
)

set(HEADERS
)

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

surgsim_add_executable(ShowScenery "${SOURCES}" "${HEADERS}")

SET(LIBS
	SurgSimBlocks
	SurgSimGraphics
	${Boost_LIBRARIES}
	${YAML_CPP_LIBRARIES}
)

target_link_libraries(ShowScenery ${LIBS})

# Put ShowScenery into folder "Examples"
set_target_properties(ShowScenery PROPERTIES FOLDER "Examples")

=== Examples/Stapling/CMakeLists.txt ===
# This file is a part of the OpenSurgSim project.
# Copyright 2013, SimQuest Solutions Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
)

set(STAPLING_SOURCES
	StapleElement.cpp
	StaplerBehavior.cpp
	Stapling.cpp
)
set(STAPLING_HEADERS
	StapleElement.h
	StaplerBehavior.h
)
surgsim_add_executable(Stapling "${STAPLING_SOURCES}" "${STAPLING_HEADERS}")

set(SERIALIZEDSTAPLING_SOURCES
	SerializedStapling.cpp
	StapleElement.cpp
	StaplerBehavior.cpp
)
set(SERIALIZEDSTAPLING_HEADERS
	StapleElement.h
	StaplerBehavior.h
)
surgsim_add_executable(SerializedStapling "${SERIALIZEDSTAPLING_SOURCES}" "${SERIALIZEDSTAPLING_HEADERS}")

set(LIBS 
	IdentityPoseDevice
	MultiAxisDevice
	SurgSimBlocks
	SurgSimFramework
	SurgSimGraphics
	${YAML_CPP_LIBRARIES}
)
target_link_libraries(Stapling ${LIBS})
target_link_libraries(SerializedStapling ${LIBS})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Configure the path for the data files
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/config.txt.in"
	"${CMAKE_CURRENT_BINARY_DIR}/config.txt"
)

set_target_properties(Stapling PROPERTIES FOLDER "Examples") 
set_target_properties(SerializedStapling PROPERTIES FOLDER "Examples")

=== debian/changelog ===
opensurgsim (0.7.0-9) unstable; urgency=medium

  * Team upload
  * Fix ggc 9 build Closes #925797 

 -- Olivier Sallou <osallou@debian.org>  Sun, 09 Feb 2020 17:22:37 +0000

opensurgsim (0.7.0-8) unstable; urgency=medium

  * Team upload.
  * Point Vcs fields to salsa.debian.org
  * debhelper 12
  * Standards-Version: 4.3.0
  * Secure URI in copyright format
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/changelog
  * Remove trailing whitespace in debian/copyright
  * Do not run test SurgSimGraphicsTest which fails for strange reasons
    Avoids bug #912110
  * Adapt to libyaml-cpp 0.6.2.patch
  * Multiarch

 -- Andreas Tille <tille@debian.org>  Tue, 29 Jan 2019 15:30:29 +0100

opensurgsim (0.7.0-7) unstable; urgency=medium

  * Team upload.

  [ Steve Langasek ]
  * Fix for build failure with boost 1.65

  [ Andreas Tille ]
  * Standards-Version: 4.1.3
  * debhelper 11
  * Install NOTICE file

 -- Andreas Tille <tille@debian.org>  Tue, 20 Mar 2018 11:28:00 +0100

opensurgsim (0.7.0-6) unstable; urgency=medium

  * Team upload

  [ Fabian Klötzl ]
  * ignore failing unit tests
    Closes: #853599

  [ Andreas Tille ]
  * Standards-Version: 4.1.2

 -- Fabian Klötzl <kloetzl@evolbio.mpg.de>  Thu, 07 Dec 2017 13:53:35 +0100

opensurgsim (0.7.0-5) unstable; urgency=medium

  * Team upload
  * Do not fail on build time tests on armhf where test results would need
    specific adjustment of tolerance otherwise
    Closes:  #847321

 -- Andreas Tille <tille@debian.org>  Thu, 08 Dec 2016 11:22:10 +0100

opensurgsim (0.7.0-4) unstable; urgency=medium

  * Team upload.

  [ Ghislain Antony Vaillant ]
  * Fix FTBFS on architectures where ASSERT_DEATH is not supported.
    - New patch Assert-death-only-if-supported.patch.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 05 Dec 2016 22:09:36 +0000

opensurgsim (0.7.0-3) unstable; urgency=medium

  * Team upload.

  [ Ghislain Antony Vaillant ]
  * Fix FTBFS when building with newest googletest.
    - Build depends on new unified googletest package.
    - Inject path to googlemock via GOOGLEMOCK_DIR.
    - Exclude gtest / gmock artefacts from install.
    Thanks to Lucas Nussbaum for reporting (Closes: #844874)

  [ Andreas Tille ]
  * debhelper 10
  * d/watch: version=4

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 05 Dec 2016 08:49:16 +0000

opensurgsim (0.7.0-2) unstable; urgency=medium

  * Disable BasicThreadTest.RealTimings
  * Only build multiaxis on linux kernels
  * Disable Thread Pool on armel

 -- Paul Novotny <paul@paulnovo.us>  Tue, 25 Oct 2016 16:49:05 -0400

opensurgsim (0.7.0-1) unstable; urgency=medium

  * New upstream version 0.7.0
  * Remove patches that have been applied upstream
  * Refresh old patches
  * Disable Eigen alignment on arm64, armel, armhf (Closes: #838270)
  * Update copyright years
  * Add patch to fix Hurd builds
  * Fixes FTBFS (test failure) on arm64 (Closes: #838271)
  * Fixes strict epsilons in MatrixTests (Closes: #838272)
  * Add hardening +bindnow
  * Add needed Depends to libopensurgsim-dev

 -- Paul Novotny <paul@paulnovo.us>  Sat, 15 Oct 2016 12:38:54 -0400

opensurgsim (0.6.0-6) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload
  * cme fix dpkg-control
  * Fix FTBFS with GCC 6 (thanks for the patch to Graham Inggs
    <ginggs@debian.org>)
    Closes: #831096

  [ Paul Novotny ]
  * Fix FTBFS with eigen3 3.3~beta2-1 (Closes: #835417)

 -- Andreas Tille <tille@debian.org>  Thu, 08 Sep 2016 22:39:37 +0200

=== debian/control ===
Source: opensurgsim
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Paul Novotny <paul@paulnovo.us>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               dh-linktree,
               dh-exec,
               libboost-chrono-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               cmake,
               doxygen,
               libeigen3-dev,
               googletest,
               libjs-jquery,
               libjs-mathjax,
               libopenscenegraph-dev,
               libyaml-cpp-dev (>= 0.5.2),
               libgmock-dev,
               libgtest-dev
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/opensurgsim
Vcs-Git: https://salsa.debian.org/med-team/opensurgsim.git
Homepage: http://www.opensurgsim.org/

Package: libopensurgsim
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Free platform for surgical simulation - runtime
 OpenSurgSim is C++ toolkit for developing real-time surgical simulations. It
 lets you build simulators using the included building blocks, such as input
 device support, haptic feedback, graphics, collision detection and physics
 simulation.
 .
 This package contains the libraries needed to run OpenSurgSim
 applications.

Package: libopensurgsim-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libopensurgsim (= ${binary:Version}),
         libboost-chrono-dev,
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libeigen3-dev,
         libopenscenegraph-dev,
         libyaml-cpp-dev
Description: Free platform for surgical simulation - development
 OpenSurgSim is C++ toolkit for developing real-time surgical simulations. It
 lets you build simulators using the included building blocks, such as input
 device support, haptic feedback, graphics, collision detection and physics
 simulation.
 .
 This package contains the development files needed to build your
 own OpenSurgSim applications.

Package: opensurgsim-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Suggests: libopensurgsim-dev,
          libopensurgsim
Description: Free platform for surgical simulation - documentation
 OpenSurgSim is C++ toolkit for developing real-time surgical simulations. It
 lets you build simulators using the included building blocks, such as input
 device support, haptic feedback, graphics, collision detection and physics
 simulation.
 .
 This package contains the Doxygen documentation files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=-format,+bindnow
export GOOGLEMOCK_DIR = /usr/src/googletest/googlemock

%:
	dh $@ --with linktree

ifeq (,$(filter $(DEB_BUILD_ARCH),i386 arm64 armel armhf powerpc ppc64el ppc64))
    EIGEN_ALIGNMENT=ON
else
    EIGEN_ALIGNMENT=OFF
endif

ifeq ($(DEB_TARGET_ARCH_OS),linux)
    BUILD_DEVICE_MULTIAXIS=ON
else
    BUILD_DEVICE_MULTIAXIS=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DBUILD_DEVICE_MULTIAXIS:BOOL=$(BUILD_DEVICE_MULTIAXIS) \
	-DBUILD_DOCUMENTATION:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING_EIGEN:BOOL=ON \
	-DCTEST_CUSTOM_TESTS_IGNORE="MultiAxisDeviceTest" \
	-DEIGEN_ALIGNMENT=$(EIGEN_ALIGNMENT) \
	-DUSE_SYSTEM_YAMLCPP:BOOL=ON

override_dh_install:
	dh_install --exclude=gmock --exclude=gtest

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_BUILD_ARCH), armhf))
	@echo "Do normal testing for all architectures except armhf"
	dh_auto_test
else
	@echo "ignore test failures for armhf but leave it as output in the logs"
	# see https://bugs.debian.org/847321
	dh_auto_test || true
endif
endif

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/opensurgsim-$1\.tar\.gz/ \
  https://github.com/simquest/opensurgsim/releases .*/v?(\d\S*)\.tar\.gz
